global function OnWeaponPrimaryAttack_shifter
global function MpAbilityShifterWeapon_Init
global function MpAbilityShifterWeapon_OnWeaponTossPrep
global function AbilityShifter_ApplyInProgressStimIfNeeded
global function move
global function stuck
global vector origpos = <0,0,0>
global bool ongoingcount = false
global bool rewindused = false

const SHIFTER_WARMUP_TIME = 0.0
const SHIFTER_WARMUP_TIME_FAST = 0.0

const string PHASEEXIT_IMPACT_TABLE_PROJECTILE	= "default"
const string PHASEEXIT_IMPACT_TABLE_TRACE		= "superSpectre_groundSlam_impact"

struct
{
	int phaseExitExplodeImpactTable
} file;

void function MpAbilityShifterWeapon_Init()
{
	// "exp_rocket_archer"
	// "exp_xlarge"
	// "exp_arc_ball"
	file.phaseExitExplodeImpactTable = PrecacheImpactEffectTable( PHASEEXIT_IMPACT_TABLE_PROJECTILE )
	PrecacheImpactEffectTable( PHASEEXIT_IMPACT_TABLE_TRACE )
}

void function MpAbilityShifterWeapon_OnWeaponTossPrep( entity weapon, WeaponTossPrepParams prepParams )
{
	entity weaponOwner = weapon.GetWeaponOwner()
	int pmLevel = GetPVEAbilityLevel( weapon )
	if ( (pmLevel >= 2) && IsValid( weaponOwner ) && weaponOwner.IsPhaseShifted() )
		weapon.SetScriptTime0( Time() )
	else
		weapon.SetScriptTime0( 0.0 )
}

int function GetPVEAbilityLevel( entity weapon )
{
	if ( weapon.HasMod( "pm2" ) )
		return 2
	if ( weapon.HasMod( "pm1" ) )
		return 1
	if ( weapon.HasMod( "pm0" ) )
		return 0

	return -1
}


/////////////////////////////////////////custom part///////////////////////////////////////////////////
const float PMMOD_ENDLESS_STRENGTH = 0.8
var function OnWeaponPrimaryAttack_shifter( entity weapon, WeaponPrimaryAttackParams attackParams ){
	entity player = weapon.GetWeaponOwner()
	thread move(player , weapon)
	return 0
}
///////////////////////////////////////////////////////////////////////////////////////////////////////

void function ApplyInProgressStimIfNeededThread( entity player )
{
	wait 0.5  // timed to kick in when the notify appears on player's screen

	if ( !IsAlive( player ) )
		return
	if ( !player.IsPhaseShifted() )
		return

	EndlessStimBegin( player, PMMOD_ENDLESS_STRENGTH )
}

void function AbilityShifter_ApplyInProgressStimIfNeeded( entity player )
{
	thread ApplyInProgressStimIfNeededThread( player )
}

void function DoPhaseExitExplosion( entity player, entity phaseWeapon )
{
#if CLIENT
	if ( !phaseWeapon.ShouldPredictProjectiles() )
		return
#endif //

	player.PhaseShiftCancel()

	vector origin = player.GetWorldSpaceCenter() + player.GetForwardVector() * 16.0

	DebugDrawLine( player.GetWorldSpaceCenter(), origin, 255, 0, 0, true, 5.0 )

	int damageType = (DF_RAGDOLL | DF_EXPLOSION | DF_ELECTRICAL)
	entity nade = phaseWeapon.FireWeaponGrenade( origin, <0,0,1>, <0,0,0>, 0.01, damageType, damageType, true, true, true )
	if ( !nade )
		return

	player.PhaseShiftBegin( 0, 1.0 )

	nade.SetImpactEffectTable( file.phaseExitExplodeImpactTable )
	nade.GrenadeExplode( <0,0,0> )

#if SERVER
	PlayImpactFXTable( player.GetOrigin(), player, PHASEEXIT_IMPACT_TABLE_TRACE, SF_ENVEXPLOSION_INCLUDE_ENTITIES )
#endif //
}

/////////////////////////////////////////custom functions///////////////////////////////////////////////////
void function move (entity player, entity weapon) {

	#if SERVER



	if (weapon.GetWeaponPrimaryClipCount() == 400 ) {
	float velmultiplier;

	if (GetCurrentPlaylistVarInt("#Boost_Strength",0) == 0) {velmultiplier = 1;}
	if(GetCurrentPlaylistVarInt("#Boost_Strength",0) == 1){velmultiplier = 1.5;}
	if(GetCurrentPlaylistVarInt("#Boost_Strength",0) == 2){velmultiplier = 2;}

	origpos = player.GetOrigin()
	PhaseShift(player, 0, 0.2 )
	vector viewvector = player.GetViewVector() * 1000 * velmultiplier
	player.SetVelocity(viewvector)
	weapon.SetWeaponPrimaryClipCount(200)
	}
	else if(weapon.GetWeaponPrimaryClipCount() == 200 && GetCurrentPlaylistVarInt("#Enable_Phase_Rewind",1) == 1) {
		thread moveback(player,origpos)
		weapon.SetWeaponPrimaryClipCount(0)
	}

	resetscharge(weapon)

	#endif
}

void function moveback (entity player , vector origpos) {
	#if SERVER
	rewindused = true;
	entity mover = CreateOwnedScriptMover (player)
	player.SetParent(mover)
	PhaseShift(player, 0, 0.5 )
	mover.NonPhysicsMoveTo (<origpos.x,origpos.y,origpos.z>, 0.5,0,0)
	wait 0.5;
	player.SetVelocity(<0,0,0>)
	player.ClearParent()
	mover.Destroy()
	#endif
}

void function resetscharge (entity weapon) {
	#if SERVER
	if (ongoingcount == false) {
		ongoingcount = true
		int x = 0
		int deco_x = 5
		while (x < 5) {

			try {if (rewindused == false && GetCurrentPlaylistVarInt("#Enable_Phase_Rewind",1) == 1){SendHudMessage(weapon.GetWeaponOwner(),"Rewind Possible: "+string(deco_x),-1,0.65,255,255,255,1,0,1,0)}}
			catch(exception) {print(exception)}
			x++
			deco_x = deco_x -1
			print(x)
			wait 1;
		}

		try {
			weapon.SetWeaponPrimaryClipCount(400)
			rewindused = false;
			SendHudMessage(weapon.GetWeaponOwner(),"Boost Ready!",-1,0.65,255,255,255,1,0,1,0) //player //text //x //y //r //g //b  /a  //fade-in s //lenght s //fade-out s
		} catch(exception) {
			print(exception)
		}

		ongoingcount = false
	}
	#endif
}

void function stuck (entity player) {
	#if SERVER
	entity mover = CreateOwnedScriptMover (player)
	player.SetParent(mover)
	vector pos = player.GetOrigin()
	mover.NonPhysicsMoveTo (<pos.x,pos.y,pos.z + 100>, 0.1,0,0)
	wait 0.3;
	player.SetVelocity(<0,0,0>)
	player.ClearParent()
	mover.Destroy()
	#endif
}